/////////////////////////////////////////////////////////////////////////////
// Name:        wxGoogleTranslateClientMainFrame.h
// Purpose:     
// Author:      Volodymir (T-Rex) Tryapichko
// Modified by: 
// Created:     31/10/2008 14:27:09
// RCS-ID:      
// Copyright:   Volodymir (T-Rex) Tryapichko, 2008
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#ifndef _WXGOOGLETRANSLATECLIENTMAINFRAME_H_
#define _WXGOOGLETRANSLATECLIENTMAINFRAME_H_


/*!
 * Includes
 */

////@begin includes
#include "wx/frame.h"
#include "wx/gbsizer.h"
////@end includes

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_WXGOOGLETRANSLATECLIENTMAINFRAME 10000
#define ID_PANEL 10001
#define ID_SOURCE_TEXTCTRL 10002
#define ID_SOURCE_LANGUAGE_CHOICE 10003
#define ID_RESULT_LANGUAGE_CHOICE 10004
#define ID_RESULT_TEXTCTRL 10005
#define ID_TRANSLATE 10006
#define SYMBOL_WXGOOGLETRANSLATECLIENTMAINFRAME_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX
#define SYMBOL_WXGOOGLETRANSLATECLIENTMAINFRAME_TITLE _("Google Translate Client")
#define SYMBOL_WXGOOGLETRANSLATECLIENTMAINFRAME_IDNAME ID_WXGOOGLETRANSLATECLIENTMAINFRAME
#define SYMBOL_WXGOOGLETRANSLATECLIENTMAINFRAME_SIZE wxSize(300, 260)
#define SYMBOL_WXGOOGLETRANSLATECLIENTMAINFRAME_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * wxGoogleTranslateClientMainFrame class declaration
 */

class wxGoogleTranslateClientMainFrame: public wxFrame
{    
    DECLARE_CLASS( wxGoogleTranslateClientMainFrame )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    wxGoogleTranslateClientMainFrame();
    wxGoogleTranslateClientMainFrame( wxWindow* parent, wxWindowID id = SYMBOL_WXGOOGLETRANSLATECLIENTMAINFRAME_IDNAME, const wxString& caption = SYMBOL_WXGOOGLETRANSLATECLIENTMAINFRAME_TITLE, const wxPoint& pos = SYMBOL_WXGOOGLETRANSLATECLIENTMAINFRAME_POSITION, const wxSize& size = SYMBOL_WXGOOGLETRANSLATECLIENTMAINFRAME_SIZE, long style = SYMBOL_WXGOOGLETRANSLATECLIENTMAINFRAME_STYLE );

    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_WXGOOGLETRANSLATECLIENTMAINFRAME_IDNAME, const wxString& caption = SYMBOL_WXGOOGLETRANSLATECLIENTMAINFRAME_TITLE, const wxPoint& pos = SYMBOL_WXGOOGLETRANSLATECLIENTMAINFRAME_POSITION, const wxSize& size = SYMBOL_WXGOOGLETRANSLATECLIENTMAINFRAME_SIZE, long style = SYMBOL_WXGOOGLETRANSLATECLIENTMAINFRAME_STYLE );

    /// Destructor
    ~wxGoogleTranslateClientMainFrame();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin wxGoogleTranslateClientMainFrame event handler declarations

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_TRANSLATE
    void OnTRANSLATEClick( wxCommandEvent& event );

    /// wxEVT_UPDATE_UI event handler for ID_TRANSLATE
    void OnTRANSLATEUpdate( wxUpdateUIEvent& event );

////@end wxGoogleTranslateClientMainFrame event handler declarations

////@begin wxGoogleTranslateClientMainFrame member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end wxGoogleTranslateClientMainFrame member function declarations
	void FillLanguageChoice(wxChoice * choice);

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin wxGoogleTranslateClientMainFrame member variables
    wxTextCtrl* m_SourceTextCtrl;
    wxChoice* m_SourceLanguageChoice;
    wxChoice* m_ResultLanguageChoice;
    wxTextCtrl* m_ResultTextCtrl;
////@end wxGoogleTranslateClientMainFrame member variables
};

#endif
    // _WXGOOGLETRANSLATECLIENTMAINFRAME_H_
